diff -ruN ../nakedmudv2.7/src/zone.h src/zone.h
--- ../nakedmudv2.7/src/zone.h	Sun Jul 31 17:13:54 2005
+++ src/zone.h	Fri Oct  7 14:15:55 2005
@@ -13,7 +13,7 @@
 
 //
 // Create a new zone, with vnums bounded between (inclusive) min and max
-ZONE_DATA *newZone(int vnum, int min, int max);
+ZONE_DATA *newZone(const char *key);
 
 //
 // Delete a zone, plus all of the prototypes contained within.
@@ -26,13 +26,7 @@
 
 //
 // Load a zone from disk. 
-ZONE_DATA *zoneLoad(WORLD_DATA *world, int vnum);
-
-//
-// load a zone from disk. Uses the old storage scheme
-ZONE_DATA *zoneLoadOld(WORLD_DATA *world, int vnum);
-bool   zoneIsOldFormat(WORLD_DATA *world, int vnum);
-void zoneConvertFormat(ZONE_DATA  *zone);
+ZONE_DATA *zoneLoad(WORLD_DATA *world, const char *key);
 
 //
 // Save a zone to the specified directory path
@@ -53,62 +47,11 @@
 
 
 //*****************************************************************************
-// add, remove, and save functions
-//*****************************************************************************
-
-//
-// add the thing to the zone, but do not save it to disk
-void   zoneAddRoom(ZONE_DATA *zone, ROOM_DATA *room);
-void    zoneAddMob(ZONE_DATA *zone, CHAR_DATA *mob);
-void    zoneAddObj(ZONE_DATA *zone, OBJ_DATA *obj);
-void zoneAddScript(ZONE_DATA *zone, SCRIPT_DATA *script);
-void zoneAddDialog(ZONE_DATA *zone, DIALOG_DATA *dialog);
-
-//
-// remove the thing from the zone (including removing it from disk)
-ROOM_DATA     *zoneRemoveRoom(ZONE_DATA *zone, int room);
-CHAR_DATA      *zoneRemoveMob(ZONE_DATA *zone, int mob);
-OBJ_DATA       *zoneRemoveObj(ZONE_DATA *zone, int obj);
-SCRIPT_DATA *zoneRemoveScript(ZONE_DATA *zone, int script);
-DIALOG_DATA *zoneRemoveDialog(ZONE_DATA *zone, int script);
-
-//
-// save the thing to disk
-void   zoneSaveRoom(ZONE_DATA *zone, ROOM_DATA   *room);
-void    zoneSaveMob(ZONE_DATA *zone, CHAR_DATA   *ch);
-void    zoneSaveObj(ZONE_DATA *zone, OBJ_DATA    *obj);
-void zoneSaveScript(ZONE_DATA *zone, SCRIPT_DATA *script);
-void zoneSaveDialog(ZONE_DATA *zone, DIALOG_DATA *dialog);
-
-//
-// return whether or not the thing is loaded in RAM
-bool   zoneIsRoomLoaded(ZONE_DATA *zone, int vnum);
-bool    zoneIsMobLoaded(ZONE_DATA *zone, int vnum);
-bool    zoneIsObjLoaded(ZONE_DATA *zone, int vnum);
-bool zoneIsScriptLoaded(ZONE_DATA *zone, int vnum);
-bool zoneIsDialogLoaded(ZONE_DATA *zone, int vnum);
-
-//
-// unloads something from memory. Assumes it is not being used by anything
-// at the moment (e.g. rooms don't have chars/objects in them)
-void   zoneUnloadRoom(ZONE_DATA *zone, int vnum);
-void    zoneUnloadMob(ZONE_DATA *zone, int vnum);
-void    zoneUnloadObj(ZONE_DATA *zone, int vnum);
-void zoneUnloadScript(ZONE_DATA *zone, int vnum);
-void zoneUnloadDialog(ZONE_DATA *zone, int vnum);
-
-
-
-//*****************************************************************************
 // get and set functions for zones
 //*****************************************************************************
 
 //
 // various get functions for zones
-int            zoneGetVnum(ZONE_DATA *zone);
-int        zoneGetMinBound(ZONE_DATA *zone);
-int        zoneGetMaxBound(ZONE_DATA *zone);
-int        getFreeRoomVnum(ZONE_DATA *zone);
 int      zoneGetPulseTimer(ZONE_DATA *zone);
 int           zoneGetPulse(ZONE_DATA *zone);
 WORLD_DATA   *zoneGetWorld(ZONE_DATA *zone);
@@ -116,18 +59,12 @@
 const char    *zoneGetDesc(ZONE_DATA *zone);
 const char *zoneGetEditors(ZONE_DATA *zone);
 BUFFER  *zoneGetDescBuffer(ZONE_DATA *zone);
-ROOM_DATA     *zoneGetRoom(ZONE_DATA *zone, int room);
-CHAR_DATA      *zoneGetMob(ZONE_DATA *zone, int room);
-OBJ_DATA       *zoneGetObj(ZONE_DATA *zone, int obj);
-SCRIPT_DATA *zoneGetScript(ZONE_DATA *zone, int script);
-DIALOG_DATA *zoneGetDialog(ZONE_DATA *zone, int dialog);
 void *zoneGetAuxiliaryData(const ZONE_DATA *zone, char *name);
+LIST    *zoneGetResettable(ZONE_DATA *zone);
+
 
 //
 // various set functions for zones
-void       zoneSetVnum(ZONE_DATA *zone, int vnum);
-void   zoneSetMinBound(ZONE_DATA *zone, int min);
-void   zoneSetMaxBound(ZONE_DATA *zone, int max);
 void zoneSetPulseTimer(ZONE_DATA *zone, int timer);
 void      zoneSetPulse(ZONE_DATA *zone, int pulse_left);
 void      zoneSetWorld(ZONE_DATA *zone, WORLD_DATA *world);
@@ -135,19 +72,18 @@
 void       zoneSetDesc(ZONE_DATA *zone, const char *description);
 void    zoneSetEditors(ZONE_DATA *zone, const char *names);
 
-//
-// set a room as needing to be reset when our zone is pulsed
-void    zoneAddResettableRoom(ZONE_DATA *zone, int vnum);
-void zoneRemoveResettableRoom(ZONE_DATA *zone, int vnum);
-
-
-
-//*****************************************************************************
-// misc stuff
-//*****************************************************************************
 
 //
-// returns true if the char has edit priviledges for the zone
-bool canEditZone(ZONE_DATA *zone, CHAR_DATA *ch);
+// stuff for editing different prototypes stored in zones
+void        zoneSetKey(ZONE_DATA *zone, const char *key);
+const char *zoneGetKey(ZONE_DATA *zone);
+void      *zoneGetType(ZONE_DATA *zone, const char *type, const char *key);
+void   *zoneRemoveType(ZONE_DATA *zone, const char *type, const char *key);
+void      zoneSaveType(ZONE_DATA *zone, const char *type, const char *key);
+void       zonePutType(ZONE_DATA *zone, const char *type, const char *key,
+		       void *data);
+void       zoneAddType(ZONE_DATA *zone, const char *type, void *reader,
+		       void *storer, void *deleter, void *keysetter);
+LIST  *zoneGetTypeKeys(ZONE_DATA *zone, const char *type);
 
 #endif // __ZONE_H
diff -ruN ../nakedmudv2.7/lib/pymodules/__restricted_builtin__.py lib/pymodules/__restricted_builtin__.py
--- ../nakedmudv2.7/lib/pymodules/__restricted_builtin__.py	Wed Dec 31 17:00:00 1969
+++ lib/pymodules/__restricted_builtin__.py	Fri Oct  7 14:16:10 2005
@@ -0,0 +1,18 @@
+################################################################################
+#
+# __restricted_builtin__.py
+#
+# This module is designed to replace the __builtin__, but overwrite many of the
+# functions that would allow an unscrupulous scripter to take malicious actions
+#
+################################################################################
+from __builtin__ import *
+from __restricted_builtin_funcs__ import r_import, r_open, r_execfile, r_eval, \
+     r_reload, r_exec, r_unload
+
+# override some dangerous functions with their safer versions
+__import__   = r_import
+execfile     = r_execfile
+open         = r_open
+eval         = r_eval
+reload       = r_reload
diff -ruN ../nakedmudv2.7/lib/pymodules/__restricted_builtin_funcs__.py lib/pymodules/__restricted_builtin_funcs__.py
--- ../nakedmudv2.7/lib/pymodules/__restricted_builtin_funcs__.py	Wed Dec 31 17:00:00 1969
+++ lib/pymodules/__restricted_builtin_funcs__.py	Fri Oct  7 14:16:10 2005
@@ -0,0 +1,44 @@
+################################################################################
+#
+# __restricted_builtin_funcs__.py
+#
+# This contains functions used by __restricted_builtin__ to do certain
+# potentially dangerous actions in a safe mode
+#
+################################################################################
+import __builtin__
+
+def r_import(name, globals = {}, locals = {}, fromlist = []):
+    """Restricted version of __import__ only allows importing of specific
+    modules"""
+
+    ok_modules = ("mud", "obj", "char", "room", "exit", "event",
+                  "action", "random", "traceback", "__restricted_builtin__")
+    if name not in ok_modules:
+        raise ImportError, "Untrusted module, %s" % name
+    return __builtin__.__import__(name, globals, locals, fromlist)
+
+def r_open(file, mode = "r", buf = -1):
+    if mode not in ('r', 'rb'):
+        raise IOError, "can't open files for writing in restricted mode"
+    return open(file, mode, buf)
+
+def r_exec(code):
+    """exec is disabled in restricted mode"""
+    raise NotImplementedError,"execution of code is disabled"
+
+def r_eval(code):
+    """eval is disabled in restricted mode"""
+    raise NotImplementedError,"evaluating code is disabled"
+
+def r_execfile(file):
+    """executing files is disabled in restricted mode"""
+    raise NotImplementedError,"executing files is disabled"
+
+def r_reload(module):
+    """reloading modules is disabled in restricted mode"""
+    raise NotImplementedError, "reloading modules is disabled"
+
+def r_unload(module):
+    """unloading modules is disabled in restricted mode"""
+    raise NotImplementedError, "unloading modules is disabled"
diff -ruN ../nakedmudv2.7/lib/pymodules/demo.py lib/pymodules/demo.py
--- ../nakedmudv2.7/lib/pymodules/demo.py	Sun Jul 31 17:14:01 2005
+++ lib/pymodules/demo.py	Fri Oct  7 14:16:10 2005
@@ -37,10 +37,10 @@
 # this command takes in 4 arguments: the character who performed it, the command
 # name, a subcommand value, and the argument supplied to the command. ch is
 # a Character, cmd is a string, subcmd is an int, and arg is a string
-def cmd_pycmd(ch, cmd, subcmd, arg):
+def cmd_pycmd(ch, cmd, arg):
     ch.send("Hello, " + ch.name + ". This is a demo Python command!")
 
 # let the MUD know it should add a command. This works exactly like add_cmd in 
 # the C source. Good examples of how to use it can be found in interpret.c
-add_cmd('pycmd', None, cmd_pycmd, 0, 'unconcious', 'flying', 'admin', 
+add_cmd('pycmd', None, cmd_pycmd, 'unconcious', 'flying', 'admin', 
 	False, False)
